[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.14 and 1.22

version 1.14, 2021/10/17 23:25:14 version 1.22, 2021/11/11 02:05:56
Line 6 
Line 6 
         sed -n "$1" /var/run/dmesg.boot          sed -n "$1" /var/run/dmesg.boot
 }  }
   
 installed_firmware() {  prefetcharea_fs_list() {
         for fw in ${PKGDIR}/$1-firmware*; do      echo "/mnt/tmp"
                 [ -e "$fw" ] || continue  
                 echo ${fw##*/}  
         done  
 }  }
   reset_watchdog() {
   }
   
 # tmpdir, do_as, unpriv, and unpriv2 are from install.sub  # tmpdir, do_as, unpriv, and unpriv2 are from install.sub
   
Line 70 
Line 69 
         do_as _file "$@"          do_as _file "$@"
 }  }
   
   # "fail" needs to be replaced with the "ask_yn" loop like in the installer.
 _issue=  _issue=
 fail() {  fail() {
         echo $_issue >&2          echo $_issue >&2
Line 96 
Line 96 
   
 FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}  FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
 FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub  FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
 PKGDIR=${DESTDIR}/var/db/pkg  FWPATTERNS="file:${0%/*}/firmware_patterns"
 PATTERNS="file:${0%/*}/firmware_patterns"  
   
   # TODO: support srclocal installation of firmware somehow
 fw_update() {  fw_update() {
         local _tmpsrc _f _remove _r          local _src=$FWURL _tmpfs_list _tmpfs _tmpsrc
         local _src=$FWURL _t=Get _cfile="/tmp/SHA256" _srclocal=false      local _t=Get _cfile="/tmp/SHA256" _srclocal=false
         local _drivers=$(          local _f _r _remove _i _installed
           local _pkgdir=/mnt/var/db/pkg
           local _d _drivers=$(
                 last=''                  last=''
                 ftp -D "Detecting" -Vmo- $PATTERNS |                  ftp -D "Detecting" -Vmo- $FWPATTERNS |
                 while read d m; do                  while read _d _m; do
                         grep=grep                          grep=grep
                         [ "$last" = "$d" ] && continue                          [ "$last" = "$_d" ] && continue
                         [ "$m" ] || m="^$d[0-9][0-9]* at "                          [ "$_m" ] || _m="^$_d[0-9][0-9]* at "
                         [ "$m" = "${m#^}" ] && grep=fgrep                          [ "$_m" = "${_m#^}" ] && grep=fgrep
                         $grep -q "$m" /var/run/dmesg.boot || continue                          $grep -q "$_m" /var/run/dmesg.boot || continue
                         echo $d                          echo $_d
                         last=$d                          last=$_d
                 done                  done
         )          )
   
         if [ -z "$_drivers" ]; then          if [ -z "$_drivers" ]; then
                 echo "No devices found which need firmware files to be downloaded." >&2                  echo "No devices found which need firmware files to be downloaded."
                 return                  return
         fi          fi
   
         if _tmpsrc=$( tmpdir "${DESTDIR}/tmp/fw_update" ); then          ! _tmpfs_list=$(prefetcharea_fs_list) &&
                 (                  echo "Cannot determine prefetch area" >&2 && return
                 >$_tmpsrc/t &&  
                 $_unpriv cat $_tmpsrc/t  
                 ) >/dev/null 2>&1 ||  
                     rm -r $_tmpsrc  
         fi  
   
           for _tmpfs in $_tmpfs_list; do
                   # Try to clean up from previous runs, assuming
                   # the _tmpfs selection yields the same mount
                   # point.
                   for _tmpsrc in $_tmpfs/firmware.+([0-9]).+([0-9]); do
                           [[ -d $_tmpsrc ]] && rm -r $_tmpsrc
                   done
   
                   # Create a download directory for the firmware and
                   # check that the _sndio user can read files from
                   # it. Otherwise cleanup and skip the filesystem.
                   if _tmpsrc=$(tmpdir "$_tmpfs/firmware"); then
                           (
                           >$_tmpsrc/t &&
                           $_unpriv cat $_tmpsrc/t
                           ) >/dev/null 2>&1 && break ||
                                   rm -r $_tmpsrc
                   fi
           done
   
         [[ ! -d $_tmpsrc ]] &&          [[ ! -d $_tmpsrc ]] &&
                 _issue="Cannot create prefetch area" && fail                  echo "Cannot create prefetch area" >&2 && return 1
   
           # Cleanup from previous runs.
           rm -f $_cfile $_cfile.sig
   
           _t=Get/Verify
   
         ! $_unpriv ftp -D "$_t" -Vmo - "$_src/SHA256.sig" >"$_cfile.sig" &&          ! $_unpriv ftp -D "$_t" -Vmo - "$_src/SHA256.sig" >"$_cfile.sig" &&
             _issue="Cannot fetch SHA256.sig" && fail              echo "Cannot fetch SHA256.sig" >&2 && return 1
   
         # Verify signature file with public keys.          # Verify signature file with public keys.
         ! unpriv -f "$_cfile" \          ! unpriv -f "$_cfile" \
             signify -Vep $FWPUB_KEY -x "$_cfile.sig" -m "$_cfile" &&              signify -Vep $FWPUB_KEY -x "$_cfile.sig" -m "$_cfile" &&
             _issue="Signature check of SHA256.sig failed" && fail              echo "Signature check of SHA256.sig failed" >&2 && return 1
   
         for d in $_drivers; do          for _d in $_drivers; do
                 _f=$( sed -n "s/.*(\($d-firmware-.*\.tgz\)).*/\1/p" "$_cfile" )                  $UU && reset_watchdog
                 installed=$( installed_firmware "$d" )                  _f=$( sed -n "s/.*(\($_d-firmware-.*\.tgz\)).*/\1/p" "$_cfile" )
                   _installed=$(
                   for fw in "${_pkgdir}/$_d-firmware"*; do
                           [ -e "$fw" ] || continue
                           echo ${fw##*/}
                   done
                   )
   
                 for i in $installed; do                  for _i in $_installed; do
                         if [ "$_f" = "$i.tgz" ]; then                          if [ "$_f" = "$_i.tgz" ]; then
                                 echo "Firmware for $d already installed ($installed)"                                  echo "Firmware for $_d already installed ($_installed)"
                                 continue 2                                  continue 2
                         fi                          fi
                 done                  done
   
                 rm -f /tmp/h /tmp/fail                  rm -f /tmp/h /tmp/fail
   
                 _t=Get/Verify  
                 # Fetch firmware file and create a checksum by piping through                  # Fetch firmware file and create a checksum by piping through
                 # sha256. Create a flag file in case ftp failed. Firmware                  # sha256. Create a flag file in case ftp failed. Firmware
                 # from net is written to the prefetch area.                  # from net is written to the prefetch area.
Line 164 
Line 191 
                 # Handle failed transfer.                  # Handle failed transfer.
                 if [[ -f /tmp/fail ]]; then                  if [[ -f /tmp/fail ]]; then
                         rm -f "$_tmpsrc/$_f"                          rm -f "$_tmpsrc/$_f"
                         _issue="Fetching of $_f failed!"                          echo "Fetching of $_f failed!" >&2
                         fail                          continue
                 fi                  fi
   
                 # Verify firmware by comparing its checksum with SHA256.                  # Verify firmware by comparing its checksum with SHA256.
                 if fgrep -qx "SHA256 ($_f) = $(</tmp/h)" "$_cfile"; then                  if ! fgrep -qx "SHA256 ($_f) = $(</tmp/h)" "$_cfile"; then
                         #_unver=$(rmel $_f $_unver)  
                         true  
                 else  
                         [[ -d "$_tmpsrc" ]] && rm -rf "$_tmpsrc"                          [[ -d "$_tmpsrc" ]] && rm -rf "$_tmpsrc"
                         _issue="Checksum test for $_f failed."                          echo "Checksum test for $_f failed." >&2
                         fail                          continue
                 fi                  fi
   
                 # TODO: Check hash for files before deleting                  # TODO: Check hash for files before deleting
                 if [ "$installed" ] && [ -e "${PKGDIR}/$installed/+CONTENTS" ]; then                  if [ "$_installed" ] && [ -e "${_pkgdir}/$_installed/+CONTENTS" ]; then
                         echo "Uninstalling $installed"                          echo "Uninstalling $_installed"
                         cwd=${PKGDIR}/$installed                          cwd=${_pkgdir}/$_installed
   
                         set -A _remove -- "${cwd}/+CONTENTS" "${cwd}"                          set -A _remove -- "${cwd}/+CONTENTS" "${cwd}"
   
                         while read c g; do                          while read c g; do
                                 case $c in                                  case $c in
                                 @cwd) cwd="${DESTDIR}/$g"                                  @cwd) cwd="/mnt/$g"
                                   ;;                                    ;;
                                 @*) continue                                  @*) continue
                                   ;;                                    ;;
                                 *)  set -A _remove -- "$cwd/$c" "${_remove[@]}"                                  *)  set -A _remove -- "$cwd/$c" "${_remove[@]}"
                                   ;;                                    ;;
                                 esac                                  esac
                         done < "${PKGDIR}/$installed/+CONTENTS"                          done < "${_pkgdir}/$_installed/+CONTENTS"
   
                           # We specifically rm -f here because not removing files/dirs
                           # is probably not worth failing over.
                         for _r in "${_remove[@]}" ; do                          for _r in "${_remove[@]}" ; do
                                 if [ -d "$_r" ]; then                                  if [ -d "$_r" ]; then
                                         # Try hard not to actually remove recursively                                          # Try hard not to actually remove recursively
Line 207 
Line 233 
                         done                          done
                 fi                  fi
   
         # TODO: Add some details about the install to +CONTENTS like pkg_add                  # TODO: Should we mark these so real fw_update can -Drepair?
         # TODO: Or, maybe we save the firmware someplace and make pkg_add reinstall  
                 echo "Installing $_f"                  echo "Installing $_f"
                 tar -zxphf "$_tmpsrc/$_f" -C "${DESTDIR}/etc" "firmware/*"                  tar -zxphf "$_tmpsrc/$_f" -C "/mnt/etc" "firmware/*"
                 mkdir -p ${PKGDIR}/${_f%.tgz}/                  mkdir -p ${_pkgdir}/${_f%.tgz}/
                 tar -zxphf "$_tmpsrc/$_f" -C "${PKGDIR}/${_f%.tgz}" "+*"                  tar -zxphf "$_tmpsrc/$_f" -C "${_pkgdir}/${_f%.tgz}" "+*"
                 ed -s "${PKGDIR}/${_f%.tgz}/+CONTENTS" <<EOL                  ed -s "${_pkgdir}/${_f%.tgz}/+CONTENTS" <<EOL
 /^@comment pkgpath/ -1a  /^@comment pkgpath/ -1a
 @option manual-installation  @option manual-installation
 @option firmware  @option firmware

Legend:
Removed from v.1.14  
changed lines
  Added in v.1.22

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>